#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdint.h>
#include <string.h>

#include "lib.h"
#define SIZE (1024*1024)

int main(int argc, char *argv[]){
	char *p;
	pid_t pid;
	unsigned long phys;

	/* 1Mバイト確保 */
	p=malloc(SIZE);
	if(!p){
		exit(1);
	}

	/* メモリを1Mバイト全て 0x55 で埋める */
	memset(p, 0x55, SIZE);

	/* 先頭を "0123" に書き換えて物理メモリ番地を表示 */
	p[0]='0';
	p[1]='1';
	p[2]='2';
	p[3]='3';
	phys=vaddr_to_phys(0, p);

	printf("\nfork()\n\n");

	pid=fork();	/* 子プロセスを作る */
	if(pid==0){
		/* 子プロセス */
		/* 物理メモリを表示 */
		phys=vaddr_to_phys(0, p);	/* リスト(A) の箇所 */

		printf("copy_on_write()\n\n");
		p[0]='A';
		p[1]='B';
		p[2]='C';
		p[3]='D';

		phys=vaddr_to_phys(0, p);	/* リスト(B) の箇所 */
		while(1){
			printf("pid=%d, virt=0x%x, phys=0x%x, sleep...\n", getpid(),p,phys);
			sleep(10);
		}
		return 0;

	}

	/* 親プロセス */
	while(1){
		printf("pid=%d, virt=0x%x, phys=0x%x, sleep...\n", getpid(),p,phys);
		sleep(10);
	}
	return 0;
}
