#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdint.h>

#include "lib.h"

#define DEVMEM	"/dev/mem"

int main(int argc, char *argv[]){
	int fd;
	unsigned char *mem_map;
	off_t offset;
	size_t length=4096;

	if(! argv[1]){
		printf("usage:\n");
		printf("%s start_addr, [length]\n",argv[0]);
		exit(1);
	}

	/* 第一引数は物理アドレスの指定(offset) */
	if(argv[1]){
		offset = strtoul(argv[1], NULL, 0);
	}

	/* 第二引数は表示する長さ。省略時は 4096バイト */
	if(argv[2]){
		length = strtoul(argv[2], NULL, 0);
	}

	/* ファイルをopenする */
	fd=open(DEVMEM, O_RDONLY);
	if(fd<=0){
		perror(DEVMEM);
		exit(1);
	}

	/* fd を使ってmmap する(ポインタが戻る) offsetと長さを指定している */
	mem_map = mmap(0, length, PROT_READ, MAP_SHARED, fd, offset);
	if(mem_map == MAP_FAILED){
		perror(argv[1]);
		exit(1);
	}

	/* 画面に16進数ダンプ */
	hexdump(mem_map, length, (void*)offset);

	/* mmap を閉じる*/
	munmap((void*)mem_map, length);

	/* デバイスを閉じる*/
	close(fd);
	return 0;
}
