#include <sys/time.h> 
#include <sys/resource.h> 
#include <stdio.h>
#include <malloc.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>

#define DEVNAME "/dev/mem"

#define BUS_CLOCK	83333333	/* 83MHz */
#define TPU_HZ		25			/* 25Hz */

#define TPU_TSTR	0xa4c90000
#define TPU_BASE0	0xa4c90010
#define TPU_BASE1	0xa4c90050
#define TPU_BASE2	0xa4c90090
#define TPU_BASE3	0xa4c900d0
#define TPU_TCR		0x00
#define TPU_TMDR	0x04
#define TPU_TIOR	0x08
#define TPU_TIER	0x0C
#define TPU_TSR		0x10
#define TPU_TCNT	0x14
#define TPU_TGRA	0x18
#define TPU_TGRB	0x1c
#define TPU_TGRC	0x20
#define TPU_TGRD	0x24


struct tpudrv_dev{
	unsigned long ch;
	unsigned long base;
	unsigned long hz;
	unsigned long interval;
	unsigned long pre_scale;
	unsigned long tgra;
	unsigned long max;
};

int dev_mmap(void);
int tpu_init_struct(struct tpudrv_dev *dev);
int tpu_init(struct tpudrv_dev *dev);
unsigned short tpu_tcnt(struct tpudrv_dev *dev);
void tpu_start(struct tpudrv_dev *dev);
void tpu_stop(struct tpudrv_dev *dev);
void tpu_start_all(void);
void tpu_stop_all(void);

int tpudrv_calc_usec(struct tpudrv_dev *dev, unsigned long cnt);
int tpu_init_all(struct tpudrv_dev *tpudrv_dev);
void tpu_set_tgra(struct tpudrv_dev *dev, unsigned short value);
