#include "cpu.h"
#include "port.h"

int board_init(void)
{

//データ初期値

// PINP:入力  POUT:出力  PMOD:周辺モジュール  0:未使用  PIN_:プルアップ無し入力
//                        7,   6,   5,   4,    3,   2,   1,   0
	PORT_CONTROL(PACR, PINP,PINP,PINP,PINP, PINP,PINP,PINP,PINP);	/* Port A : */
	PORT_CONTROL(PBCR, PMOD,PMOD,PINP,PINP, PINP,PINP,PMOD,PMOD);	/* Port B :  */
	PORT_CONTROL(PFCR, PINP,PINP,PINP,PINP, PINP,PMOD,PINP,PINP);	/* Port F : PF2=TXD0 */
	PORT_CONTROL(PGCR,    0,   0,POUT,POUT, POUT,POUT,POUT,POUT);	/* Port G :  */

	PORT_CONTROL(PJCR, POUT,POUT,PMOD,PMOD, PMOD,PMOD,PMOD,PMOD);	/* Port J : */
	PORT_CONTROL(PMCR, PINP,PINP,PINP,PINP, PINP,PINP,PMOD,POUT);	/* Port M : PM1=RXD  */
	PORT_CONTROL(PRCR, PMOD,PMOD,PINP,PINP, PMOD,PMOD,PMOD,PMOD);	/* Port R :  */
	PORT_CONTROL(PUCR, PINP,PINP,PINP,PINP, PINP,PINP,PINP,PINP);	/* Port U :  */

	PORT_CONTROL(PWCR, PMOD,PMOD,PMOD,PMOD, PMOD,PMOD,PMOD,PMOD);	/* Port W : SDHI1 */
	PORT_CONTROL(PYCR, PMOD,PMOD,PMOD,PMOD, PMOD,PMOD,PMOD,PMOD);	/* Port Y : SDHI0 */
	PORT_CONTROL(PZCR, PMOD,PMOD,PMOD,PMOD, PMOD,PMOD,PMOD,PMOD);	/* Port Z : SCIF3, IRQ */

/*ピンセレクトA */
	*PSELA =  (1<<13) | (1<<6); 		/* (SDHI1) (SCIF0) */

/*ピンセレクトB */
	*PSELB =  0x6c00; 		/* 0b 0110 1100 0000 0000 */

/*ピンセレクトE */
	*PSELE =  (1<<12);					/* (SDHI1) */

/* モジュール機能選択レジスタ */
	*MSELCRB = (1<<5);	/* SCIF3 */

	*DRVCRA = 0x0003;


// 補足説明
// 各ピンは可能な限り入力に初期化

// プルアップ制御レジスタ(ハードウェアリセット値に戻す)

	return 0;
}
