/* 5章 例外 */

#define _TRA      0xFF000020   /* TRAPA例外レジスタ           32 */
#define _EXPEVT   0xFF000024   /* 例外事象レジスタ            32 */
#define _INTEVT   0xFF000028   /* 割り込み事象レジスタ        32 */
#define _EXPMASK  0xFF2F0004   /* 非サポート検出例外レジスタ  32 */


/* 7章 MMU */
#define _TEA       0xFF00000C   /* TLB 例外アドレスレジスタ   32 */
#define _MMUCR     0xFF000010

#define MMUCR      ((volatile unsigned long*)_MMUCR)
#define MMU_CONTROL_INIT_DISABLE        0x0004

/* 8章 キャッシュ */

#define _CCR       0xFF00001C   /* キャッシュ制御レジスタ      32 */
#define _QACR0     0xFF000038   /* キューアドレス制御レジスタ0 32 */
#define _QACR1     0xFF00003C   /* キューアドレス制御レジスタ1 32 */
#define _RAMCR     0xFF000074   /* 内蔵メモリ制御レジスタ      32 */

#define CCR      ((volatile unsigned long*)_CCR)  
#define QACR0    ((volatile unsigned long*)_QACR0)
#define QACR1    ((volatile unsigned long*)_QACR1)
#define RAMCR    ((volatile unsigned long*)_RAMCR)

#define ICI     11
#define ICE     8
#define OCI     3
#define CB      2
#define WT      1
#define OCE     0

#define CCR_DISABLE     ((1<<ICI) | (1<<OCI))     /* キャッシュの無効化 */
#define CCR_OC_ENABLE   ((1<<WT)  | (1<<OCE))     /* オペランドキャッシュのみ有効 ライトスルー */
#define CCR_ENABLE      ((1<<ICE) | (1<<WT) | (1<<OCE))     /* 命令キャッシュ、オペランドキャッシュ有効 ライト スルー */
#define CCR_ENABLE_WB   ((1<<ICE) | (1<<OCE))    /* 命令キャッシュ、オペランドキャッシュ有効 ライトバック */


/* 14章 バスステートコントローラ */

#define _MMSELR    0xFF800020   /* メモリアドレスマップ選択レジスタ      32 */
#define _CMNCR     0xFEC10000   /* 共通コントロールレジスタ              32 */
#define _CS0BCR    0xFEC10004   /* CS0 空間バスコントロールレジスタ      32 */
#define _CS4BCR    0xFEC10010   /* CS4 空間バスコントロールレジスタ      32 */
#define _CS5ABCR   0xFEC10014   /* CS5A 空間バスコントロールレジスタ     32 */
#define _CS5BBCR   0xFEC10018   /* CS5B 空間バスコントロールレジスタ     32 */
#define _CS6ABCR   0xFEC1001C   /* CS6A 空間バスコントロールレジスタ     32 */
#define _CS6BBCR   0xFEC10020   /* CS6B 空間バスコントロールレジスタ     32 */
#define _CS0WCR    0xFEC10024   /* CS0 空間ウェイトコントロールレジスタ  32 */
#define _CS4WCR    0xFEC10030   /* CS4 空間ウェイトコントロールレジスタ  32 */
#define _CS5AWCR   0xFEC10034   /* CS5A 空間ウェイトコントロールレジスタ 32 */
#define _CS5BWCR   0xFEC10038   /* CS5B 空間ウェイトコントロールレジスタ 32 */
#define _CS6AWCR   0xFEC1003C   /* CS6A 空間ウェイトコントロールレジスタ 32 */
#define _CS6BWCR   0xFEC10040   /* CS6B 空間ウェイトコントロールレジスタ 32 */
#define _RBWTCNT   0xFEC10054   /* リセットバスウェイトカウンタ          32 */

#define MMSELR    ((volatile unsigned long*)_MMSELR )
#define CMNCR     ((volatile unsigned long*)_CMNCR  )
#define CS0BCR    ((volatile unsigned long*)_CS0BCR )
#define CS4BCR    ((volatile unsigned long*)_CS4BCR )
#define CS5ABCR   ((volatile unsigned long*)_CS5ABCR)
#define CS5BBCR   ((volatile unsigned long*)_CS5BBCR)
#define CS6ABCR   ((volatile unsigned long*)_CS6ABCR)
#define CS6BBCR   ((volatile unsigned long*)_CS6BBCR)
#define CS0WCR    ((volatile unsigned long*)_CS0WCR )
#define CS4WCR    ((volatile unsigned long*)_CS4WCR )
#define CS5AWCR   ((volatile unsigned long*)_CS5AWCR)
#define CS5BWCR   ((volatile unsigned long*)_CS5BWCR)
#define CS6AWCR   ((volatile unsigned long*)_CS6AWCR)
#define CS6BWCR   ((volatile unsigned long*)_CS6BWCR)
#define RBWTCNT   ((volatile unsigned long*)_RBWTCNT)


/* 15章 DDR 用バスコントローラ（DBSC） */

#define _DBKIND     0xFD000008  /* DBSC SDRAM種類設定レジスタ                    */
#define _DBSTATE    0xFD00000C  /* DBSC ステータスレジスタ                       */
#define _DBEN       0xFD000010  /* SDRAM 動作許可レジスタ                        */
#define _DBCMDCNT   0xFD000014  /* SDRAM コマンド制御レジスタ                    */
#define _DBCKECNT   0xFD000018  /* SDRAM CKE 制御レジスタ                        */
#define _DBCONF     0xFD000020  /* SDRAM 構成設定レジスタ                        */
#define _DBTR0      0xFD000030  /* SDRAM タイミングレジスタ0                     */
#define _DBTR1      0xFD000034  /* SDRAM タイミングレジスタ1                     */
#define _DBTR2      0xFD000038  /* SDRAM タイミングレジスタ2                     */
#define _DBTR3      0xFD00003C  /* SDRAM タイミングレジスタ3                     */
#define _DBRFPDN0   0xFD000040  /* SDRAM リフレッシュ／パワーダウン制御レジスタ0 */
#define _DBRFPDN1   0xFD000044  /* SDRAM リフレッシュ／パワーダウン制御レジスタ1 */
#define _DBRFPDN2   0xFD000048  /* SDRAM リフレッシュ／パワーダウン制御レジスタ2 */
#define _DBRFSTS    0xFD00004C  /* SDRAM リフレッシュステータスレジスタ          */
#define _DBMRCNT    0xFD000060  /* SDRAM モード設定レジスタ                      */
#define _DBPDCNT0   0xFD000108  /* DDR-PHY 部制御レジスタ0                       */

#define DBKIND   ((volatile unsigned long*)_DBKIND)
#define DBSTATE  ((volatile unsigned long*)_DBSTATE)
#define DBEN     ((volatile unsigned long*)_DBEN)
#define DBCMDCNT ((volatile unsigned long*)_DBCMDCNT)
#define DBCKECNT ((volatile unsigned long*)_DBCKECNT)
#define DBCONF   ((volatile unsigned long*)_DBCONF)
#define DBTR0    ((volatile unsigned long*)_DBTR0)
#define DBTR1    ((volatile unsigned long*)_DBTR1)
#define DBTR2    ((volatile unsigned long*)_DBTR2)
#define DBTR3    ((volatile unsigned long*)_DBTR3)
#define DBRFPDN0 ((volatile unsigned long*)_DBRFPDN0)
#define DBRFPDN1 ((volatile unsigned long*)_DBRFPDN1)
#define DBRFPDN2 ((volatile unsigned long*)_DBRFPDN2)
#define DBRFSTS  ((volatile unsigned long*)_DBRFSTS)
#define DBMRCNT  ((volatile unsigned long*)_DBMRCNT)
#define DBPDCNT0 ((volatile unsigned long*)_DBPDCNT0)


/* 17章 クロックパルス発振器 */

#define _FRQCRA    0xA4150000  /* 周波数制御レジスタA              32 */
#define _FRQCRB    0xA4150004  /* 周波数制御レジスタB              32 */
#define _VCLKCR    0xA4150048  /* ビデオクロック周波数制御レジスタ 32 */
#define _FCLKACR   0xA4150008  /* FSI クロックA 周波数制御レジスタ 32 */
#define _FCLKBCR   0xA415000C  /* FSI クロックB 周波数制御レジスタ 32 */
#define _IRDACLKCR 0xA4150018  /* IRDA クロック周波数制御レジスタ  32 */
#define _SPUCLKCR  0xA415003C  /* SPU クロック周波数制御レジスタ   32 */
#define _PLLCR     0xA4150024  /* PLL 制御レジスタ                 32 */
#define _FLLFRQ    0xA4150050  /* FLL 逓倍レジスタ                 32 */
#define _LSTATS    0xA4150060  /* 周波数変更ステータスレジスタ     32 */

#define FRQCRA    ((volatile unsigned long*)_FRQCRA   )
#define FRQCRB    ((volatile unsigned long*)_FRQCRB   )
#define VCLKCR    ((volatile unsigned long*)_VCLKCR   )
#define FCLKACR   ((volatile unsigned long*)_FCLKACR  )
#define FCLKBCR   ((volatile unsigned long*)_FCLKBCR  )
#define IRDACLKCR ((volatile unsigned long*)_IRDACLKCR)
#define SPUCLKCR  ((volatile unsigned long*)_SPUCLKCR )
#define PLLCR     ((volatile unsigned long*)_PLLCR    )
#define FLLFRQ    ((volatile unsigned long*)_FLLFRQ   )
#define LSTATS    ((volatile unsigned long*)_LSTATS   )

/* 20章  タイマユニット（TMU） */
/*          TMU は32bitのカウントダウンタイマ */

#define _TMU_TSTR0     0xFFD80004   /* タイマスタートレジスタ0          8 */
#define _TMU_BASE0_0   0xFFD80008
#define _TMU_BASE0_1   0xFFD80014
#define _TMU_BASE0_2   0xFFD80020
#define _TMU_TSTR1     0xFFD90004   /* タイマスタートレジスタ1          8 */
#define _TMU_BASE1_0   0xFFD90008
#define _TMU_BASE1_1   0xFFD90014
#define _TMU_BASE1_2   0xFFD90020

#define _TMU_TCOR      0x00    /* タイマ・コンスタント・レジスタ */
#define _TMU_TCNT      0x04    /* タイマ・カウンタ */
#define _TMU_TCR       0x08    /* タイマ・コントロール・レジスタ */

#define TMU_TCOR(dev)   ((volatile unsigned long*)  (((dev)->base)+_TMU_TCOR)  )
#define TMU_TCNT(dev)   ((volatile unsigned long*)  (((dev)->base)+_TMU_TCNT)  )
#define TMU_TCR(dev)    ((volatile unsigned short*) (((dev)->base)+_TMU_TCR)   )

#define TMU_STR0	0x01
#define TMU_TCR_UNIE	(1<<5)
#define TMU_TCR_UNF		(1<<8)


/* 21章  16 ビットタイマパルスユニット（TPU） */

#define _TPU_TSTR	0xa4c90000
#define _TPU_BASE0	0xa4c90010
#define _TPU_BASE1	0xa4c90050
#define _TPU_BASE2	0xa4c90090
#define _TPU_BASE3	0xa4c900d0
#define _TPU_TCR	0x00
#define _TPU_TMDR	0x04
#define _TPU_TIOR	0x08
#define _TPU_TIER	0x0C
#define _TPU_TSR	0x10
#define _TPU_TCNT	0x14
#define _TPU_TGRA	0x18
#define _TPU_TGRB	0x1c
#define _TPU_TGRC	0x20
#define _TPU_TGRD	0x24

#define TPU_TSTR            ((volatile unsigned short*)(TPU_TSTR))
#define TPU_TCR(base)       ((volatile unsigned short*)((base)+_TPU_TCR))  
#define TPU_TMDR(base)      ((volatile unsigned short*)((base)+_TPU_TMDR)) 
#define TPU_TIOR(base)      ((volatile unsigned short*)((base)+_TPU_TIOR)) 
#define TPU_TIER(base)      ((volatile unsigned short*)((base)+_TPU_TIER)) 
#define TPU_TSR(base)       ((volatile unsigned short*)((base)+_TPU_TSR))  
#define TPU_TCNT(base)      ((volatile unsigned short*)((base)+_TPU_TCNT)) 
#define TPU_TGRA(base)      ((volatile unsigned short*)((base)+_TPU_TGRA)) 
#define TPU_TGRB(base)      ((volatile unsigned short*)((base)+_TPU_TGRB)) 
#define TPU_TGRC(base)      ((volatile unsigned short*)((base)+_TPU_TGRC)) 
#define TPU_TGRD(base)      ((volatile unsigned short*)((base)+_TPU_TGRD)) 


/* 26章 FIFO 内蔵シリアルコミュニケーションインタフェース（SCIF）*/

#define _SCSMR0  0xFFE00000   /* シリアルモードレジスタ0            16 */
#define _SCBRR0  0xFFE00004   /* ビットレートレジスタ0              8  */
#define _SCSCR0  0xFFE00008   /* シリアルコントロールレジスタ0      16 */
#define _SCFTDR0 0xFFE0000C   /* トランスミットFIFO データレジスタ0 8  */
#define _SCFSR0  0xFFE00010   /* シリアルステータスレジスタ0        16 */
#define _SCFRDR0 0xFFE00014   /* レシーブFIFO レジスタ0             8  */
#define _SCFCR0  0xFFE00018   /* FIFO コントロールレジスタ0         16 */
#define _SCFDR0  0xFFE0001C   /* FIFO データ数レジスタ0             16 */
#define _SCLSR0  0xFFE00024   /* ラインステータスレジスタ0          16 */

#define _SCSMR1  0xFFE10000   /* シリアルモードレジスタ1            16 */
#define _SCBRR1  0xFFE10004   /* ビットレートレジスタ1              8  */
#define _SCSCR1  0xFFE10008   /* シリアルコントロールレジスタ1      16 */
#define _SCFTDR1 0xFFE1000C   /* トランスミットFIFO データレジスタ1 8  */
#define _SCFSR1  0xFFE10010   /* シリアルステータスレジスタ1        16 */
#define _SCFRDR1 0xFFE10014   /* レシーブFIFO レジスタ1             8  */
#define _SCFCR1  0xFFE10018   /* FIFO コントロールレジスタ1         16 */
#define _SCFDR1  0xFFE1001C   /* FIFO データ数レジスタ1             16 */
#define _SCLSR1  0xFFE10024   /* ラインステータスレジスタ1          16 */

#define _SCSMR2  0xFFE20000   /* シリアルモードレジスタ2            16 */
#define _SCBRR2  0xFFE20004   /* ビットレートレジスタ2              8  */
#define _SCSCR2  0xFFE20008   /* シリアルコントロールレジスタ2      16 */
#define _SCFTDR2 0xFFE2000C   /* トランスミットFIFO データレジスタ2 8  */
#define _SCFSR2  0xFFE20010   /* シリアルステータスレジスタ2        16 */
#define _SCFRDR2 0xFFE20014   /* レシーブFIFO レジスタ2             8  */
#define _SCFCR2  0xFFE20018   /* FIFO コントロールレジスタ2         16 */
#define _SCFDR2  0xFFE2001C   /* FIFO データ数レジスタ2             16 */
#define _SCLSR2  0xFFE20024   /* ラインステータスレジスタ2          16 */

#define SCSMR0  ((volatile unsigned short*)_SCSMR0  )
#define SCBRR0  ((volatile unsigned char*) _SCBRR0  )
#define SCSCR0  ((volatile unsigned short*)_SCSCR0  )
#define SCFTDR0 ((volatile unsigned char*) _SCFTDR0 )
#define SCFSR0  ((volatile unsigned short*)_SCFSR0  )
#define SCFRDR0 ((volatile unsigned char*) _SCFRDR0 )
#define SCFCR0  ((volatile unsigned short*)_SCFCR0  )
#define SCFDR0  ((volatile unsigned short*)_SCFDR0  )
#define SCLSR0  ((volatile unsigned short*)_SCLSR0  )

#define SCSMR1  ((volatile unsigned short*)_SCSMR1  )
#define SCBRR1  ((volatile unsigned char*) _SCBRR1  )
#define SCSCR1  ((volatile unsigned short*)_SCSCR1  )
#define SCFTDR1 ((volatile unsigned char*) _SCFTDR1 )
#define SCFSR1  ((volatile unsigned short*)_SCFSR1  )
#define SCFRDR1 ((volatile unsigned char*) _SCFRDR1 )
#define SCFCR1  ((volatile unsigned short*)_SCFCR1  )
#define SCFDR1  ((volatile unsigned short*)_SCFDR1  )
#define SCLSR1  ((volatile unsigned short*)_SCLSR1  )

#define SCSMR2  ((volatile unsigned short*)_SCSMR2  )
#define SCBRR2  ((volatile unsigned char*) _SCBRR2  )
#define SCSCR2  ((volatile unsigned short*)_SCSCR2  )
#define SCFTDR2 ((volatile unsigned char*) _SCFTDR2 )
#define SCFSR2  ((volatile unsigned short*)_SCFSR2  )
#define SCFRDR2 ((volatile unsigned char*) _SCFRDR2 )
#define SCFCR2  ((volatile unsigned short*)_SCFCR2  )
#define SCFDR2  ((volatile unsigned short*)_SCFDR2  )
#define SCLSR2  ((volatile unsigned short*)_SCLSR2  )

#define SCSMR_CHR         0x0040
#define SCSMR_PE          0x0020
#define SCSMR_OE          0x0010
#define SCSMR_STOP        0x0008
#define SCSMR_CKS1        0x0002
#define SCSMR_CKS0        0x0001

#define SCSCR_TIE         0x0080
#define SCSCR_RIE         0x0040
#define SCSCR_TE          0x0020
#define SCSCR_RE          0x0010
#define SCSCR_MPIE    0x0008
#define SCSCR_TEIE    0x0004
#define SCSCR_CKE1        0x0002
#define SCSCR_CKE0        0x0001

#define SCFSR_ER          0x0080
#define SCFSR_TEND        0x0040
#define SCFSR_TDFE        0x0020
#define SCFSR_BRK         0x0010
#define SCFSR_FER         0x0008
#define SCFSR_PER         0x0004
#define SCFSR_RDF         0x0002
#define SCFSR_DR          0x0001

#define SCFCR_RTRG1  0x0080
#define SCFCR_RTRG0  0x0040
#define SCFCR_TTRG1  0x0020
#define SCFCR_TTRG0  0x0010
#define SCFCR_MCE         0x0008
#define SCFCR_TFRST  0x0004
#define SCFCR_RFRST  0x0002
#define SCFCR_LOOP        0x0001
