#include "cpu.h"

	.global	bsr_init

	.text
	.align	2

bsr_init:

/* BSR */
        mov.l   MMSELR_A,r1       /* CMNCR Address */
        mov.l   MMSELR_D,r0       /* CMNCR Data */
        mov.l   r0,@r1

        mov.l   CMNCR_A,r1       /* CMNCR Address */
        mov.l   CMNCR_D,r0       /* CMNCR Data */
        mov.l   r0,@r1

        mov.l   CS0BCR_A,r1      /* CS0BCR Address */
        mov.l   CS0BCR_D,r0      /* CS0BCR Data */
        mov.l   r0,@r1

        mov.l   CS6ABCR_A,r1     /* CS6ABCR Address */
        mov.l   CS6ABCR_D,r0     /* CS6ABCR Data */
        mov.l   r0,@r1

        mov.l   CS6BBCR_A,r1     /* CS6BBCR Address */
        mov.l   CS6BBCR_D,r0     /* CS6BBCR Data */
        mov.l   r0,@r1

        mov.l   CS0WCR_A,r1      /* CS0WCR Address */
        mov.l   CS0WCR_D,r0      /* CS0WCR Data */
        mov.l   r0,@r1

        mov.l   CS6AWCR_A,r1     /* CS6AWCR Address */
        mov.l   CS6AWCR_D,r0     /* CS6AWCR Data */
        mov.l   r0,@r1

        mov.l   CS6BWCR_A,r1     /* CS6BWCR Address */
        mov.l   CS6BWCR_D,r0     /* CS6BWCR Data */
        mov.l   r0,@r1

/* SDRAMの初期化 */
#include "partner-jet-cmd.h"
#include "partner-jet-setup.txt"

	! BL bit off (init = ON) (?!?)

	stc	sr, r0				! BL bit off(init=ON)
	mov.l	SR_MASK_D, r1
	and	r1, r0
	ldc	r0, sr

	rts
	 mov	#0, r0

	.align	2
SR_MASK_D:	.long	0xEFFFFF0F


/* 14章 バスステートコントローラ */

MMSELR_A:	.long	_MMSELR
CMNCR_A:	.long	_CMNCR
CS0BCR_A:	.long	_CS0BCR
CS6ABCR_A:	.long	_CS6ABCR
CS6BBCR_A:	.long	_CS6BBCR
CS0WCR_A:	.long	_CS0WCR
CS6AWCR_A:	.long	_CS6AWCR
CS6BWCR_A:	.long	_CS6BWCR
DBKIND_A:	.long	_DBKIND   
DBSTATE_A:	.long	_DBSTATE  

MMSELR_D:	.long	0xa5a50000
CMNCR_D:	.long	0x0000001A
CS0BCR_D:	.long	0x36DB0400
CS6ABCR_D:	.long	0x36DB0400
CS6BBCR_D:	.long	0x36DB0400
CS0WCR_D:	.long	0x00001BC2
CS6AWCR_D:	.long	0x00001BC2
CS6BWCR_D:	.long	0x00001D43
