/*
 *  SH4 SCI
 */
#include "config.h"
#include "cpu.h"
#include "timer.h"

#define SCI_BPS	115200
#define SCI_BPS_VALUE	((MODULE_CLOCK/32/SCI_BPS)-1)	/* SCIの分周 */



/* ======================================================
 *  CPU内蔵シリアルの初期化
 * ======================================================
 */
void sci_init()
{
/* SCIF0初期化 */
	*SCSMR0 = 0;		/* 8データ,1ストップビット,no parity */
	*SCSCR0 = 0;		/* SCIを停止,内部Pクロックを使う */
	*SCFCR0 = 6;		/* FIFO リセット */
	*SCFCR0 = 0;		/* FIFO リセット終了 */
	*SCBRR0 = SCI_BPS_VALUE;

	/*
	 * ボーレートの設定後、1カウント分待たなければならない。
	 */
	usleep(100000);


	*SCFSR0 &= 0x84;	/* エラーフラグをクリア */
	*SCSCR0 = SCSCR_TE|SCSCR_RE;   /* 送信有効、受信有効  */
}

/* ======================================================
 *  デバック用
 * ======================================================
 */


/*
 * デバック用１キャラクター送信（割り込みを使わない）
 *    data   = 送信キャラクター
 */

void sci0_debug_putchar(int data)
{
	/* TDREが空くまで ループして待つ */
	while((*SCFSR0 & SCFSR_TDFE) == 0)
		;

	/* キャラクタ送信データセット */
	*SCFTDR0 = (unsigned char)data;
	/* TDREのクリア(送信開始) */
	*SCFSR0 &= ~(SCFSR_TDFE | SCFSR_TEND);
}
