#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h> 

/* dmaドライバメモリサイズ */
// #define SIZE (4*1024*1024) /* 4Mbyte*/
#define SIZE (16*1024) /* 16Kbyte*/

/* ioctl() コマンド番号 */
#define DMADRV_DMA_START 0x1000   /* Start DMA  */
#define DMADRV_DMA_STOP  0x1001   /* Stop  DMA  */

int main(int argc, char *argv[]){
	int fd;
	int i;
	int ret;
	unsigned long from,num;
	unsigned char *mem_map;

	if(! argv[1]){
		/* 使い方 */
		printf("%s map_file_name\n",argv[0]);
		exit(1);
	}

	printf("mmap test %s\n",argv[1]);
/* ファイルをopenする */
	fd=open(argv[1], O_RDWR);
	if(fd<=0){
		perror(argv[1]);
		exit(1);
	}

/* fd を使ってmmap する(ポインタが戻る)*/
	from = 0;
	num  = SIZE;
	mem_map = mmap(0, num, PROT_READ|PROT_WRITE, MAP_SHARED, fd, from);
	if(mem_map < 0){
		perror(argv[1]);
		exit(1);
	}
	printf("mmaped at %p\n",mem_map);	/* mapした仮想メモリアドレス */

/* 0x00...0x07 を繰り返しメモリに書く */
	for(i=0; i<SIZE; i++){
		mem_map[i] = i & 0x07;	// 3bit
	}

/* dma転送開始 */
	ret = ioctl(fd,DMADRV_DMA_START,SIZE);
	if(ret){
		printf("ioctl() error %d\n",ret);
	}

/* mmap を閉じる*/
	munmap((void*)mem_map, num);

/* しばらくプログラムを終わらせないため */
	sleep(100);	/* 100秒 */

/* デバイスを閉じる*/
	close(fd);

	return 0;
}
