#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

/*
 gpio-0   (GPIO_PTA7           ) in  hi
 gpio-1   (GPIO_PTA6           ) in  hi
 gpio-2   (GPIO_PTA5           ) in  hi
 gpio-3   (GPIO_PTA4           ) in  hi
 gpio-4   (GPIO_PTA3           ) in  hi
 gpio-5   (GPIO_PTA2           ) in  hi
 gpio-6   (GPIO_PTA1           ) out hi
 gpio-7   (GPIO_PTA0           ) out lo
*/

const char *gpio_device_name[]=
{
	"/sys/class/gpio/gpio7/value",
	"/sys/class/gpio/gpio6/value",
	"/sys/class/gpio/gpio5/value",
	"/sys/class/gpio/gpio4/value",
	"/sys/class/gpio/gpio3/value",
	"/sys/class/gpio/gpio2/value",
	"/sys/class/gpio/gpio1/value",
	"/sys/class/gpio/gpio0/value",
};

int gpio_portA_read(int bit)
{
	int fd;
	char str[32];
	int value;
	if(bit<0){
		exit(1);
	}
	if(bit>7){
		exit(1);
	}
	fd=open(gpio_device_name[bit],O_RDONLY);
	if(fd<0){
		perror(gpio_device_name[bit]);
		exit(1);
	}
	read(fd,str,1);
	close(fd);

	str[1]=0;
	value=atoi(str);

	return value;
}

int gpio_polling(){
	int i,value;
	for(i=0; i<8; i++){
		value = gpio_portA_read(i);
		// printf("%d,%d\n",i,value);
	}
}


int main()
{
	int x;
	for(x=0; x<10000; x++){
		gpio_polling();
	}
}

