/*
 * helldrv.c
 *   written by Y.Ebihara
 *   2005/11/9  Version 1.0   for linux-2.6 kernel
 *   2011/9/5   Version 1.1   for linux-3.0 kernel
 */

#include <linux/module.h>

// モジュールがロードされたとき(insmod されたとき)に呼ばれる
// 戻り値は
//   負:エラー発生
//   0 :正常終了
// とする。負を返すとモジュールは常駐しない

int hellodrv_init(void){
	int i=0;
	printk("hellodrv hello\n");
	printk("hellodrv_init=0x%08x, printk=0x%08x,i=0x%08x\n",
		hellodrv_init, printk, &i);


	printk("addr of jiffies %p\n",&jiffies);
	printk("size of jiffies %d\n",sizeof(jiffies));
	printk("jiffies 0x%lx\n",jiffies);

	printk("addr of jiffies64 %p\n",&jiffies_64);
	printk("size of jiffies64 %d\n",sizeof(jiffies_64));
	printk("jiffies64 0x%llx\n",jiffies_64);

	return 0;
}


// モジュールがアンロードされたときき (rmmod されたとき)に呼ばれる
// 引数も戻り値も無し

void hellodrv_exit(void){
	printk("hellodrv goodby\n");
}

// モジュールの初期化関数、終了関数を定義するマクロ
module_init(hellodrv_init);
module_exit(hellodrv_exit);

// モジュールライセンス定義マクロ
MODULE_LICENSE("GPL");
